# -*- coding: UTF-8 -*-

import _mysql, CompatMysqldb

class ConnectionBrokerChief:
    """Connection Broker Chief is intended to handle multiple Connection Brokers too (maybe) different DBs"""
    
    theConnectionPool = None


    class __ConnectionPool:
        """this SINGLETON handles all the connections and has total control to count, refuse, ... connections"""

        def __init__(self):
            pass

        def establishConnection(self, DBtype, database):
            if DBtype == "mySQL":
                return CompatMysqldb.Connection("localhost", "root", "", database), SQLstatements(DBtype)
                           
            if DBtype == "postgreSQL":
                pass

            else: print "unknown DB-type"     


    def __init__(self):
        if ConnectionBrokerChief.theConnectionPool == None:
            ConnectionBrokerChief.theConnectionPool = ConnectionBrokerChief.__ConnectionPool()

    def __getattr__(self, aName):
        return getattr(self.theConnectionPool, aName)
      
    
class ConnectionBroker:
    def __init__(self, connectionBrokerChief, DBtype, database):
        ## set the connection object and the object for SQL statements of the corresponding DB
        self.connection, self.SQLstats = connectionBrokerChief.establishConnection(DBtype, database)
        self.DBtype = DBtype ## e.g. "mySQL", "postgreSQL", ...

        ## objects, which received the one and only db-connection,
        ## for more connections, create more connection brokers
        self.objList = []

    def __del__(self):
        if self.connection: self.connection.close()

    def getSQLstatements(self):
        """returns an objekt which provides the correct SQL statements for the corresponding database"""
        return self.SQLstats
    
    def getConnection(self, objWho):
        self.objList.append(objWho)    
        return self.connection        

    def getDBtype(self):
        return self.DBtype
    
    def objReturnsConnection(self, objWho):
        self.objList.remove(objWho)

    def selectTable(self, typestring, value, returnIncreasingList=None):
        """
        builds the correct table-name with preceding 'tbl' and the type of the attribute -
        for CHAR attributes the length of the string is added to the end
        e.g. DATE -> tblDATE; INTEGER -> tblINTEGER; CHAR -> tblCHAR25
        !!! if a search is requested with 'LIKE' the list of CHAR-tables with increasing
        length is needed - e.g. searching all addresses beginning with 'Hamilton Road*'
        the method returns the list ['tblCHAR25', 'tblCHAR100', 'tblCHAR255']
        """            
        ## if it is a CHAR attribute
        if typestring.count("CHAR") == 1:
            table = "tblCHAR"
            l = len(value)
            if l <= 4:    
                table += "4"
            elif l <= 10:    
                table += "10"
            elif l <= 25:    
                table += "25"
            elif l <= 100:    
                table += "100"
            elif l <= 255:    
                table += "255"
            else: pass ## fehler generieren
            
            if returnIncreasingList:
                tblList = ["tblCHAR4", "tblCHAR10", "tblCHAR25", "tblCHAR100", "tblCHAR255"]
                return tblList[tblList.index(table):len(tblList)]
            else:
                return table
        
        ## "tbl" are first characters -> table-name is already correct
        elif typestring[0:3] == "tbl":
            return typestring
       
        ## new attribute, e.g. built with type DATE -> generate table-name
        else:
            return "tbl" + typestring
   
class SQLstatements:
    def __init__(self, DBtype):
        self.type = DBtype
        
        if DBtype == "mySQL":
            self.SEL_01 = lambda param : 'SELECT * FROM tblObjects WHERE objID=' + param
            self.SEL_02 = lambda param : 'SELECT ID, LOCKED FROM tblObjectIDs WHERE ID=' + param
            self.SEL_03 = lambda : 'SELECT last_insert_id()'
            self.SEL_04 = lambda param1, param2 : 'SELECT * FROM ' + param1 + ' WHERE attrID=' + param2

            self.LOK_01 = lambda : 'LOCK TABLES tblObjectIDs WRITE'
            self.ULK_01 = lambda : 'UNLOCK TABLES'

            self.UPD_01 = lambda param1, param2 : 'UPDATE tblObjectIDs SET LOCKED="' + param1 + '" WHERE ID=' + param2
            self.UPD_02 = lambda param : 'UPDATE tblObjectIDs SET LOCKED="0" WHERE ID=' + param
            self.UPD_03 = lambda param1, param2, param3, param4 : 'UPDATE ' + param1 + ' SET attrName="' + param2 + '", attrValue="' + param3 + '" WHERE attrID=' + param4

            self.INS_01 = lambda : 'INSERT INTO tblObjectIDs VALUES ()'
            self.INS_02 = lambda param1, param2, param3, param4 : 'INSERT INTO ' + param1 + ' (attrName, attrValue, objID) VALUES ("' + param2 + '", "' + param3 + '", ' + param4 + ')'
            self.INS_03 = lambda param1, param2, param3 : 'INSERT INTO tblObjects (objID, attrType, attrID) VALUES (' + param1 + ', "' + param2 + '", ' + param3 + ')'

            self.DEL_01 = lambda param1, param2 : 'DELETE FROM ' + param1 + ' WHERE attrID=' + param2
            self.DEL_02 = lambda param1, param2 : 'DELETE FROM tblObjects WHERE attrType="' + param1 + '" AND attrID=' + param2
            self.DEL_03 = lambda param : "DELETE FROM tblObjectIDs WHERE ID=" + param

        elif DBtype == "postgreSQL":
            ## translate the SQL strings from mySQL (above) for postgreSQL
            pass
            
    def getString(self, whichString, *urgs):
        # doppelte anfhrungsstriche erlaube ich nicht - werden durch einfache ersetzt
        # aber NICHT bei INSERT BLOB
        if whichString.count("BLOB") == 1:
            args = urgs
        else:
            args = []
            for i in range(len(urgs)):
                args.append(urgs[i].replace('"', "'"))

        if whichString == "SELECT_01": return self.SEL_01(args[0])
        elif whichString == "SELECT_02": return self.SEL_02(args[0])
        elif whichString == "SELECT_03": return self.SEL_03()
        elif whichString == "SELECT_04": return self.SEL_04(args[0], args[1])
         
        elif whichString == "LOCK_01": return self.LOK_01()
        elif whichString == "UNLOCK_01": return self.ULK_01()
        
        elif whichString == "UPDATE_01": return self.UPD_01(args[0], args[1])
        elif whichString == "UPDATE_02": return self.UPD_02(args[0])
        elif whichString == "UPDATE_03": return self.UPD_03(args[0], args[1], args[2], args[3])

        elif whichString == "INSERT_01": return self.INS_01()
        elif whichString == "INSERT_02": return self.INS_02(args[0], args[1], args[2], args[3])
        elif whichString == "INSERT_03": return self.INS_03(args[0], args[1], args[2])

        elif whichString == "INSERTBLOB_02": return self.INS_02(args[0], args[1], _mysql.escape_string(args[2]), args[3])

        elif whichString == "DELETE_01": return self.DEL_01(args[0], args[1])
        elif whichString == "DELETE_02": return self.DEL_02(args[0], args[1])
        elif whichString == "DELETE_03": return self.DEL_03(args[0])

